/***************************************************************************
                          dlgoptionhistory.h
                         -------------------
    description          : History Options Dialog Class
    begin                : Sat Sep 11 1999
    copyright            : (C) 1999 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef DLGOPTIONMEMORY_H
#define DLGOPTIONMEMORY_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qslider.h>
#include <qlcdnumber.h>
#include <qcheckbox.h>
//Generated area. DO NOT EDIT!!!(end)

#include <qwidget.h>

/**
  * History Options Dialog Class
  *@author Stephan Uhlmann
  */

class DlgOptionHistory : public QWidget  {
   Q_OBJECT
public:
	/** constructor */
	DlgOptionHistory(QWidget *parent=0, const char *name=0);
	/** destructor */
	~DlgOptionHistory();

	/** get value of QSlider for the size of the output view (lines) */
	int getOutputSize();
	/** get value of QSlider for the size of the input history (lines) */
	int getInputSize();
	/** set value of QSlider for the size of the output view (lines) */
	void setOutputSize(int);
	/** set value of QSlider for the size of the input history (lines) */
	void setInputSize(int);

	/** returns option whether to share history for input and alternative input */
	bool getSharedInputHistory();
	/** sets option whether to share history for input and alternative input */
	void setSharedInputHistory(bool);


protected:
	/** initalizes Dialog (KDevelop generated) */
	void initDialog();
	//Generated area. DO NOT EDIT!!!(begin)
	QGroupBox *buffers_GroupBox;
	QLabel *outputSize_Label;
	QSlider *outputSize_Slider;
	QLCDNumber *outputSize_LCDNumber;
	QLabel *inputSize_Label;
	QSlider *inputSize_Slider;
	QLCDNumber *inputSize_LCDNumber;
	QGroupBox *QGroupBox_2;
	QCheckBox *shareHistory_CheckBox;
	//Generated area. DO NOT EDIT!!!(end)

private:
};

#endif
