/***************************************************************************
                          dlgprofiletriggersinput.h
                      -------------------
    description          :
    begin                : Sat Jan 22 2000
    copyright            : (C) 2000 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef DLGPROFILETRIGGERSINPUT_H
#define DLGPROFILETRIGGERSINPUT_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <kcolorbtn.h>
//Generated area. DO NOT EDIT!!!(end)

#include <qdialog.h>

/**
  *@author Stephan Uhlmann
  */

class DlgProfileTriggersInput : public QDialog  {
   Q_OBJECT
public: 
	DlgProfileTriggersInput(QWidget *parent=0, const char *name=0);
	~DlgProfileTriggersInput();
	/** returns the name of the Trigger */
	QString getTrigger ();
  /** returns whether trigger is regular exprssion or not */
  bool getIsRegEx ();
	/** returns the type of the Trigger */
	int getType();
	/** returns the command of the Trigger */
	QString getCommand();
	/** returns the set foreground color option of the (Color-)Trigger */
	bool getSetFgColor();
	/** returns the foreground color of the (Color-)Trigger */
	QColor getFgColor();
	/** returns the set background color option of the (Color-)Trigger */
	bool getSetBgColor();
	/** returns the background color of the (Color-)Trigger */
	QColor getBgColor();
	/** returns the set font option of the (Color-)Trigger */
	bool getSetFont();
	/** returns the font of the (Color-)Trigger */
	QFont getFont();

  /** set's the name of the trigger */
  void setTrigger (QString Name);
  /** set's whether trigger is regular exprssion or not */
  void setIsRegEx (bool yes);
  /** set's the type of the trigger */
  void setType (int type);
  /** set's the command of the trigger */
  void setCommand (QString command);
  /** set's the set foreground color option of the (color-)trigger */
  void setSetFgColor (bool b);
  /** set's the foreground color of the (color-)trigger */
  void setFgColor (QColor fgc);
  /** set's the set background color option of the (color-)trigger */
  void setSetBgColor (bool b);
  /** set's the background color of the (color-)trigger */
  void setBgColor (QColor bgc);
  /** set's the set font option of the (color-)trigger */
  void setSetFont (bool b);
  /** set's the font of the (color-)trigger */
  void setFont (QFont font);



protected: 
	void initDialog();
	//Generated area. DO NOT EDIT!!!(begin)
	QGroupBox *action_GroupBox;
	QGroupBox *trigger_GroupBox;
	QPushButton *ok_Button;
	QPushButton *cancel_Button;
	QLabel *trigger_Label;
	QLineEdit *trigger_LineEdit;
	QRadioButton *actionSendCommand_RadioButton;
	QLineEdit *command_LineEdit;
	QRadioButton *actionColorString_RadioButton;
	QRadioButton *actionColorLine_RadioButton;
	QCheckBox *foreground_CheckBox;
	KColorButton *foreground_KColorButton;
	QCheckBox *background_CheckBox;
	KColorButton *background_KColorButton;
	QCheckBox *font_CheckBox;
	QPushButton *font_Button;
	QCheckBox *isRegEx_CheckBox;
	//Generated area. DO NOT EDIT!!!(end)


public slots:
	void slotOKPressed();
	void slotCancelPressed();
	void slotFontButtonPressed();
	void slotSetType0();
	void slotSetType1();
	void slotSetType2();
	void slotSetEnablesDisables();

private:
	QFont _font;
};

#endif
